/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKGlobal.h

	Abstract:
			FilmShrink global declarations

    License:
            GNU General Public License (GPL)

	Revision History:
			* Aug 10, 2004:  Created by Attila Afra

------------------------------------------------------------------------------
	Copyright  2004-2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#ifndef FSKGlobalH
#define FSKGlobalH

// Includes
#include <vcl.h>
#include <Registry.hpp>
#include "FSKMain.h"	// every form needs this one!

// Main
bool FSKStartup();
bool FSKInitialize();
void FSKTerminate();

// Registry
#define FSK_PRODUCT_NAME        "FilmShrink"         

#define FSK_REGKEY              "Software\\AfraTek\\FilmShrink"
#define FSK_JOBS_REGKEY         FSK_REGKEY"\\Jobs"

#define FSK_JOBS_COUNT_REGVAL   "Count"

#define FSK_JOB_NAME_REGVAL     "Name"
#define FSK_JOB_DATE_REGVAL     "Date"
#define FSK_JOB_PATH_REGVAL     "Path"
#define FSK_JOB_DONE_REGVAL     "Done"

extern TRegistry *g_Reg;

bool FSKInitReg();
bool FSKVerifyReg();
void FSKCloseReg();

// Paths
#define FSK_PRODUCER_PATH       "helix\\producer.exe"    // producer's relative path
#define FSK_README_PATH         "Readme.txt"
#define FSK_LICENSE_PATH        "License.txt"

extern AnsiString FSKAppTitle;                                     // title of the app
extern AnsiString FSKAppPath;                                      // path of the app
extern AnsiString FSKEncoderPath;                                  // path of the encoder (Helix Producer)

void FSKInitPath();

// Forms
void FSKShowSplashForm();
void FSKShowMenuForm();
void FSKShowNewForm();

// Utilities
bool RemoveDirTree(AnsiString Dir);
__int64 FileSize(AnsiString FileName);

#endif // GlobalH
