/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKMain.h

	Abstract:
			FilmShrink main form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Aug  9, 2004:  Created by Attila Afra
            * Jan 27, 2005:  Bugfixes

------------------------------------------------------------------------------
	Copyright  2004-2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#include <vcl.h>
#pragma hdrstop

// Includes
#include "FSKGlobal.h"
//#include "FSKMain.h"   <-- already included in "Global.h"!

// VCL stuff
#pragma package(smart_init)
#pragma resource "*.dfm"

// Global variables
TForm *FSKActiveForm;
bool FSKTermFlag;

// MainForm definition
TFSKMainForm *FSKMainForm;

/*-----------------------------------------------------------------------------
    Constructors
-----------------------------------------------------------------------------*/

// Default constructor
__fastcall TFSKMainForm::TFSKMainForm(TComponent* Owner)
    : TForm(Owner)
{
    // Initialization
    FSKActiveForm = NULL;
    FSKTermFlag   = false;

    // Virtually hide the form
    BorderStyle = bsNone;
    Width = 0;
    Height = 0;
    Left = Screen->DesktopWidth / 2;
    Top = Screen->DesktopHeight / 2;
}

/*-----------------------------------------------------------------------------
    Events
-----------------------------------------------------------------------------*/

void __fastcall TFSKMainForm::FormShow(TObject *Sender)
{
   // Show the splash
   FSKShowSplashForm();
}

void __fastcall TFSKMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    if (!FSKTermFlag && FSKActiveForm)
    {
        FSKTermFlag = true;
        Action = caNone;
        FSKActiveForm->Close();
    }
}

void __fastcall TFSKMainForm::FormPaint(TObject *Sender)
{
    // This form must be always invisible
    if (Visible)
        Hide();
}


