/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKNewCodec.cpp

	Abstract:
			FilmShrink "New Job" wizard's codec options form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Feb 20, 2004:  Created by Attila Afra
            * Mar 29, 2005:  Improved TEdit->Text verification

------------------------------------------------------------------------------
	Copyright  2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#include <vcl.h>
#pragma hdrstop

// Includes
#include "FSKGlobal.h"
#include "FSKNew.h"
#include "FSKNewCodec.h"

// VCL stuff
#pragma package(smart_init)
#pragma resource "*.dfm"

/*=============================================================================
    TFSKNewCodecForm
=============================================================================*/

TFSKNewCodecForm *FSKNewCodecForm;

/*-----------------------------------------------------------------------------
    TFSKNewCodecForm >> Constructors
-----------------------------------------------------------------------------*/

__fastcall TFSKNewCodecForm::TFSKNewCodecForm(TComponent* Owner) : TForm(Owner)
{
    IsActive = true;
}

/*-----------------------------------------------------------------------------
    TFSKNewCodecForm >> Events
-----------------------------------------------------------------------------*/

void __fastcall TFSKNewCodecForm::FormShow(TObject *Sender)
{
    IsActive = false;

    // Disable parent form
    FSKNewForm->Enabled = false;

    // Update info
    ManualCheck->Checked = FSKNewForm->ManualVideoCodec;
    UpdateConfig();

    IsActive = true;
    ManualCheckClick(Sender);
}

void __fastcall TFSKNewCodecForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    // Save info
    FSKNewForm->ManualVideoCodec = ManualCheck->Checked;

    FSKNewForm->rcEnableCurveCompression = RCNewCheck->Checked;
    FSKNewForm->rcHighBitrateReduce      = RCHighUpDown->Position;
    FSKNewForm->rcLowBitrateBoost        = RCLowUpDown->Position;

    FSKNewForm->rcPFrameRefQuant = RefQuantPUpDown->Position;
    FSKNewForm->rcBFrameRefQuant = RefQuantBUpDown->Position;

    FSKNewForm->inloopCutOffQuant        = InloopQuantUpDown->Position;
    FSKNewForm->inloopCutOffCompatible   = InloopCompatCheck->Checked;
    FSKNewForm->inloopCutOffBUseRefQuant = InloopBRefQuantCheck->Checked;

    FSKNewForm->AdaptiveB = BMaxRadio->Checked;
    switch (BMaxCombo->ItemIndex)
    {
    case 0:
        FSKNewForm->maxConsecutiveBFrames = 0;
        break;

    case 1:
        FSKNewForm->maxConsecutiveBFrames = 1;
        break;

    case 2:
        FSKNewForm->maxConsecutiveBFrames = 3;
        break;
    }
    FSKNewForm->patternAdaptivity = BPatternCombo->ItemIndex;

    FSKNewForm->encodeAllFrames    = MiscAllFramesCheck->Checked;
    FSKNewForm->chromaModeDecision = MiscChromaCheck->Checked;
    FSKNewForm->enableRPR          = MiscRPRCheck->Checked;

    // Enable parent form
    FSKNewForm->Enabled = true;
}

/*---------------------------------------------------------------------------*/

void __fastcall TFSKNewCodecForm::ManualCheckClick(TObject *Sender)
{
    if (!IsActive)
        return;

    if (ManualCheck->Checked)
    {
        RCNewCheck->Enabled = FSKNewForm->EHQTwoPassCheck->Checked;

        if (RCNewCheck->Checked)
        {
            RCHighLabel1->Enabled = true;
            RCHighLabel2->Enabled = true;
            RCHighEdit->Enabled   = true;
            RCHighUpDown->Enabled = true;
            RCLowLabel1->Enabled  = true;
            RCLowLabel2->Enabled  = true;
            RCLowEdit->Enabled    = true;
            RCLowUpDown->Enabled  = true;

            RefQuantPLabel->Enabled  = true;
            RefQuantPEdit->Enabled   = true;
            RefQuantPUpDown->Enabled = true;
            RefQuantBLabel->Enabled  = true;
            RefQuantBEdit->Enabled   = true;
            RefQuantBUpDown->Enabled = true;

            MiscAllFramesCheck->Enabled = false;
        }
        else
        {
            RCHighLabel1->Enabled = false;
            RCHighLabel2->Enabled = false;
            RCHighEdit->Enabled   = false;
            RCHighUpDown->Enabled = false;
            RCLowLabel1->Enabled  = false;
            RCLowLabel2->Enabled  = false;
            RCLowEdit->Enabled    = false;
            RCLowUpDown->Enabled  = false;

            RefQuantPLabel->Enabled  = false;
            RefQuantPEdit->Enabled   = false;
            RefQuantPUpDown->Enabled = false;
            RefQuantBLabel->Enabled  = false;
            RefQuantBEdit->Enabled   = false;
            RefQuantBUpDown->Enabled = false;

            MiscAllFramesCheck->Enabled = true;
        }

        InloopQuantLabel->Enabled     = true;
        InloopQuantEdit->Enabled      = true;
        InloopQuantUpDown->Enabled    = true;
        InloopCompatCheck->Enabled    = true;
        InloopBRefQuantCheck->Enabled = true;

        BMaxRadio->Enabled     = true;
        BPatternRadio->Enabled = true;

        if (BMaxRadio->Checked)
        {
            BMaxCombo->Enabled     = true;
            BPatternCombo->Enabled = false;
        }
        else
        {
            BMaxCombo->Enabled     = false;
            BPatternCombo->Enabled = true;
        }

        MiscChromaCheck->Enabled = true;
        MiscRPRCheck->Enabled    = true;
    }
    else
    {
        FSKNewForm->S4_UpdateVideoCodec();
        UpdateConfig();

        RCNewCheck->Enabled = false;

        RCHighLabel1->Enabled = false;
        RCHighLabel2->Enabled = false;
        RCHighEdit->Enabled   = false;
        RCHighUpDown->Enabled = false;
        RCLowLabel1->Enabled  = false;
        RCLowLabel2->Enabled  = false;
        RCLowEdit->Enabled    = false;
        RCLowUpDown->Enabled  = false;

        RefQuantPLabel->Enabled  = false;
        RefQuantPEdit->Enabled   = false;
        RefQuantPUpDown->Enabled = false;
        RefQuantBLabel->Enabled  = false;
        RefQuantBEdit->Enabled   = false;
        RefQuantBUpDown->Enabled = false;

        InloopQuantLabel->Enabled     = false;
        InloopQuantEdit->Enabled      = false;
        InloopQuantUpDown->Enabled    = false;
        InloopCompatCheck->Enabled    = false;
        InloopBRefQuantCheck->Enabled = false;

        BMaxRadio->Enabled     = false;
        BMaxCombo->Enabled     = false;
        BPatternRadio->Enabled = false;
        BPatternCombo->Enabled = false;

        MiscAllFramesCheck->Enabled = false;
        MiscChromaCheck->Enabled    = false;
        MiscRPRCheck->Enabled       = false;
    }
}
void __fastcall TFSKNewCodecForm::RCNewCheckClick(TObject *Sender)
{
    if (!IsActive || !ManualCheck->Checked)
        return;

    if (RCNewCheck->Checked)
    {
        RCHighLabel1->Enabled = true;
        RCHighLabel2->Enabled = true;
        RCHighEdit->Enabled   = true;
        RCHighUpDown->Enabled = true;
        RCLowLabel1->Enabled  = true;
        RCLowLabel2->Enabled  = true;
        RCLowEdit->Enabled    = true;
        RCLowUpDown->Enabled  = true;

        RefQuantPLabel->Enabled  = true;
        RefQuantPEdit->Enabled   = true;
        RefQuantPUpDown->Enabled = true;
        RefQuantBLabel->Enabled  = true;
        RefQuantBEdit->Enabled   = true;
        RefQuantBUpDown->Enabled = true;

        MiscAllFramesCheck->Enabled = false;
        MiscAllFramesCheck->Checked = true;
    }
    else
    {
        RCHighLabel1->Enabled = false;
        RCHighLabel2->Enabled = false;
        RCHighEdit->Enabled   = false;
        RCHighUpDown->Enabled = false;
        RCLowLabel1->Enabled  = false;
        RCLowLabel2->Enabled  = false;
        RCLowEdit->Enabled    = false;
        RCLowUpDown->Enabled  = false;

        RefQuantPLabel->Enabled  = false;
        RefQuantPEdit->Enabled   = false;
        RefQuantPUpDown->Enabled = false;
        RefQuantBLabel->Enabled  = false;
        RefQuantBEdit->Enabled   = false;
        RefQuantBUpDown->Enabled = false;

        MiscAllFramesCheck->Enabled = true;
    }
}

void __fastcall TFSKNewCodecForm::RCHighEditExit(TObject *Sender)
{
    if (RCHighEdit->Text.IsEmpty())
    {
        Application->MessageBoxA("Please enter an integer between 0 and 100.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
        RCHighEdit->SetFocus();
    }
    else
    {
        try
        {
            RCHighEdit->Text.ToInt();
        }
        catch (...)
        {
            Application->MessageBoxA("Please enter a valid integer between 0 and 100.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
            RCHighEdit->SetFocus();
            return;
        }

        RCHighEdit->Text = IntToStr(RCHighUpDown->Position);
    }
}

void __fastcall TFSKNewCodecForm::RCLowEditExit(TObject *Sender)
{
    if (RCLowEdit->Text.IsEmpty())
    {
        Application->MessageBoxA("Please enter an integer between 0 and 100.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
        RCLowEdit->SetFocus();
    }
    else
    {
        try
        {
            RCLowEdit->Text.ToInt();
        }
        catch (...)
        {
            Application->MessageBoxA("Please enter a valid integer between 0 and 100.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
            RCLowEdit->SetFocus();
            return;
        }

        RCLowEdit->Text = IntToStr(RCLowUpDown->Position);
    }
}

void __fastcall TFSKNewCodecForm::RefQuantPEditExit(TObject *Sender)
{
    if (RefQuantPEdit->Text.IsEmpty())
    {
        Application->MessageBoxA("Please enter an integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
        RefQuantPEdit->SetFocus();
    }
    else
    {
        try
        {
            RefQuantPEdit->Text.ToInt();
        }
        catch (...)
        {
            Application->MessageBoxA("Please enter a valid integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
            RefQuantPEdit->SetFocus();
            return;
        }

        RefQuantPEdit->Text = IntToStr(RefQuantPUpDown->Position);
    }
}

void __fastcall TFSKNewCodecForm::RefQuantBEditExit(TObject *Sender)
{
    if (RefQuantBEdit->Text.IsEmpty())
    {
        Application->MessageBoxA("Please enter an integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
        RefQuantBEdit->SetFocus();
    }
    else
    {
        try
        {
            RefQuantBEdit->Text.ToInt();
        }
        catch (...)
        {
            Application->MessageBoxA("Please enter a valid integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
            RefQuantBEdit->SetFocus();
            return;
        }

        RefQuantBEdit->Text = IntToStr(RefQuantBUpDown->Position);
    }
}

void __fastcall TFSKNewCodecForm::InloopQuantEditExit(TObject *Sender)
{
    if (InloopQuantEdit->Text.IsEmpty())
    {
        Application->MessageBoxA("Please enter an integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
        InloopQuantEdit->SetFocus();
    }
    else
    {
        try
        {
            InloopQuantEdit->Text.ToInt();
        }
        catch (...)
        {
            Application->MessageBoxA("Please enter a valid integer between 0 and 30.", FSK_PRODUCT_NAME, MB_OK | MB_ICONEXCLAMATION);
            InloopQuantEdit->SetFocus();
            return;
        }

        InloopQuantEdit->Text = IntToStr(InloopQuantUpDown->Position);
    }
}

void __fastcall TFSKNewCodecForm::BMaxRadioClick(TObject *Sender)
{
    if (!IsActive)
        return;

    if (ManualCheck->Checked)
    {
        BMaxCombo->Enabled     = true;
        BPatternCombo->Enabled = false;
    }
}

void __fastcall TFSKNewCodecForm::BPatternRadioClick(TObject *Sender)
{
    if (!IsActive)
        return;

    if (ManualCheck->Checked)
    {
        BMaxCombo->Enabled     = false;
        BPatternCombo->Enabled = true;
    }
}

void __fastcall TFSKNewCodecForm::NumEditKeyPress(TObject *Sender, char &Key)
{
    // Ignore nondigit characters
    if ((Key != 8) /* Backspace */ && !isdigit(Key))
    {
        Key = 0; // No key pressed
        MessageBeep(MB_OK);
    }
}

/*-----------------------------------------------------------------------------
    TFSKNewCodecForm >> User methods
-----------------------------------------------------------------------------*/

void TFSKNewCodecForm::UpdateConfig()
{
    RCNewCheck->Checked    = FSKNewForm->rcEnableCurveCompression;
    RCHighUpDown->Position = FSKNewForm->rcHighBitrateReduce;
    RCLowUpDown->Position  = FSKNewForm->rcLowBitrateBoost;

    RefQuantPUpDown->Position = FSKNewForm->rcPFrameRefQuant;
    RefQuantBUpDown->Position = FSKNewForm->rcBFrameRefQuant;

    InloopQuantUpDown->Position   = FSKNewForm->inloopCutOffQuant;
    InloopCompatCheck->Checked    = FSKNewForm->inloopCutOffCompatible;
    InloopBRefQuantCheck->Checked = FSKNewForm->inloopCutOffBUseRefQuant;

    if (FSKNewForm->AdaptiveB)
        BMaxRadio->Checked = true;
    else
        BPatternRadio->Checked = true;

    switch (FSKNewForm->maxConsecutiveBFrames)
    {
    case 0:
        BMaxCombo->ItemIndex = 0;
        break;

    case 1:
        BMaxCombo->ItemIndex = 1;
        break;

    case 3:
        BMaxCombo->ItemIndex = 2;
        break;
    }
    BPatternCombo->ItemIndex = FSKNewForm->patternAdaptivity;

    MiscAllFramesCheck->Checked = FSKNewForm->encodeAllFrames;
    MiscChromaCheck->Checked    = FSKNewForm->chromaModeDecision;
    MiscRPRCheck->Checked       = FSKNewForm->enableRPR;
}
