/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKNewCodec.h

	Abstract:
			FilmShrink "New Job" wizard's codec options form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Feb 20, 2004:  Created by Attila Afra

------------------------------------------------------------------------------
	Copyright  2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#ifndef FSKNewCodecH
#define FSKNewCodecH

// Includes
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

/*-----------------------------------------------------------------------------
    TFSKNewCodecForm class
-----------------------------------------------------------------------------*/

class TFSKNewCodecForm : public TForm
{
__published:
    // IDE-managed Components

    // Events
    TGroupBox *RCGroupBox;
    TCheckBox *RCNewCheck;
    TEdit *RCHighEdit;
    TUpDown *RCHighUpDown;
    TLabel *RCHighLabel1;
    TLabel *RCHighLabel2;
    TLabel *RCLowLabel1;
    TEdit *RCLowEdit;
    TUpDown *RCLowUpDown;
    TLabel *RCLowLabel2;
    TGroupBox *InloopGroupBox;
    TLabel *InloopQuantLabel;
    TEdit *InloopQuantEdit;
    TUpDown *InloopQuantUpDown;
    TCheckBox *InloopCompatCheck;
    TCheckBox *InloopBRefQuantCheck;
    TGroupBox *QuantGroupBox;
    TLabel *RefQuantPLabel;
    TEdit *RefQuantPEdit;
    TUpDown *RefQuantPUpDown;
    TLabel *RefQuantBLabel;
    TEdit *RefQuantBEdit;
    TUpDown *RefQuantBUpDown;
    TGroupBox *MiscGroupBox;
    TCheckBox *MiscAllFramesCheck;
    TCheckBox *MiscChromaCheck;
    TCheckBox *ManualCheck;
    TGroupBox *BGroupBox;
    TRadioButton *BMaxRadio;
    TComboBox *BMaxCombo;
    TRadioButton *BPatternRadio;
    TComboBox *BPatternCombo;
    TCheckBox *MiscRPRCheck;
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall ManualCheckClick(TObject *Sender);
    void __fastcall RCNewCheckClick(TObject *Sender);
    void __fastcall RCHighEditExit(TObject *Sender);
    void __fastcall RCLowEditExit(TObject *Sender);
    void __fastcall RefQuantPEditExit(TObject *Sender);
    void __fastcall RefQuantBEditExit(TObject *Sender);
    void __fastcall InloopQuantEditExit(TObject *Sender);
    void __fastcall BMaxRadioClick(TObject *Sender);
    void __fastcall BPatternRadioClick(TObject *Sender);
    void __fastcall NumEditKeyPress(TObject *Sender, char &Key);

// User declarations
private:
    bool IsActive;
    void UpdateConfig();

public:
    // Constructors
    __fastcall TFSKNewCodecForm(TComponent* Owner);
};

// External FSKNewCodecForm declaration
extern PACKAGE TFSKNewCodecForm *FSKNewCodecForm;

#endif
