/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKNewCrop.h

	Abstract:
			FilmShrink "New Job" wizard's video crop form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Mar  7, 2005:  Created by Attila Afra
            * Mar 23, 2005:  Zoom function

------------------------------------------------------------------------------
	Copyright  2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#ifndef FSKNewCropH
#define FSKNewCropH

// Includes
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>

/*-----------------------------------------------------------------------------
    TFSKNewCropForm class
-----------------------------------------------------------------------------*/

class TFSKNewCropForm : public TForm
{
__published:
    // IDE-managed Components
    TGroupBox *VideoCropGroupBox;
    TImage *VideoCropImage;
    TEdit *VideoCropBEdit;
    TEdit *VideoCropTEdit;
    TEdit *VideoCropREdit;
    TEdit *VideoCropLEdit;
    TUpDown *VideoCropLUpDown;
    TUpDown *VideoCropRUpDown;
    TUpDown *VideoCropTUpDown;
    TUpDown *VideoCropBUpDown;
    TButton *CancelButton;
    TBevel *LineBevel;
    TButton *OKButton;
    TPanel *Panel;
    TTrackBar *TrackBar;
    TImage *Image;
    TButton *ZoomButton;

    // Events
    void __fastcall FormShow(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall VideoCropTEditChange(TObject *Sender);
    void __fastcall VideoCropBEditChange(TObject *Sender);
    void __fastcall VideoCropLEditChange(TObject *Sender);
    void __fastcall VideoCropREditChange(TObject *Sender);
    void __fastcall VideoCropTEditExit(TObject *Sender);
    void __fastcall VideoCropBEditExit(TObject *Sender);
    void __fastcall VideoCropLEditExit(TObject *Sender);
    void __fastcall VideoCropREditExit(TObject *Sender);
    void __fastcall VideoCropEditKeyPress(TObject *Sender, char &Key);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall CancelButtonClick(TObject *Sender);
    void __fastcall ZoomButtonClick(TObject *Sender);
    void __fastcall TrackBarChange(TObject *Sender);
    void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall ImageMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);

// User declarations
private:
    bool Half, Update, PreviewActive;
    int FullWidth, FullHeight, HalfWidth, HalfHeight;
    int  CropTop, CropLeft, CropWidth, CropHeight;
    Graphics::TBitmap *Frame;
    int FrameWidth, FrameHeight, NumFrames;
    enum {cmNone, cmTop, cmBottom, cmLeft, cmRight} CropMode;
    bool EnableCropMode;

    void UpdateFrame();

public:
    // Constructors
    __fastcall TFSKNewCropForm(TComponent* Owner);

    // Main
    bool Init();
};

// External FSKNewCropForm declaration
extern PACKAGE TFSKNewCropForm *FSKNewCropForm;

#endif
