/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKNewFilters.cpp

	Abstract:
			FilmShrink "New Job" wizard's filter options form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Feb 17, 2004:  Created by Attila Afra

------------------------------------------------------------------------------
	Copyright  2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#include <vcl.h>
#pragma hdrstop

// Includes
#include "FSKNew.h"
#include "FSKNewFilters.h"

// VCL stuff
#pragma package(smart_init)
#pragma resource "*.dfm"

/*=============================================================================
    TFSKNewFiltersForm
=============================================================================*/

TFSKNewFiltersForm *FSKNewFiltersForm;

/*-----------------------------------------------------------------------------
    TFSKNewFiltersForm >> Constructors
-----------------------------------------------------------------------------*/

__fastcall TFSKNewFiltersForm::TFSKNewFiltersForm(TComponent* Owner) : TForm(Owner)
{
    IsActive = true;
}

/*-----------------------------------------------------------------------------
    TFSKNewFiltersForm >> Events
-----------------------------------------------------------------------------*/

void __fastcall TFSKNewFiltersForm::FormShow(TObject *Sender)
{
    // Disable parent form
    FSKNewForm->Enabled = false;

    // Get options
    IsActive = false;

    if (FSKNewForm->TitleInfo[FSKNewForm->VTS].Video.IsPAL)
    {
        IVTCMethodLabel->Enabled = false;
        IVTCMethodCombo->Enabled = false;
        IVTCFieldLabel->Enabled  = false;
        IVTCFieldCombo->Enabled  = false;
    }
    else
    {
        IVTCMethodLabel->Enabled = true;
        IVTCMethodCombo->Enabled = true;
        IVTCFieldLabel->Enabled  = true;
        IVTCFieldCombo->Enabled  = true;
    }

    if (FSKNewForm->Deinterlace)
    {
        if (FSKNewForm->FullDeinterlace)
            DeintMethodCombo->ItemIndex = 2;
        else
            DeintMethodCombo->ItemIndex = 1;
    }
    else
        DeintMethodCombo->ItemIndex = 0;

    if (FSKNewForm->IVTC)
    {
        if (FSKNewForm->ComplexIVTC)
            IVTCMethodCombo->ItemIndex = 2;
        else
            IVTCMethodCombo->ItemIndex = 1;
    }
    else
        IVTCMethodCombo->ItemIndex = 0;

    if (FSKNewForm->IsTFF)
        IVTCFieldCombo->ItemIndex = 0;
    else
        IVTCFieldCombo->ItemIndex = 1;

    IsActive = true;

    //DeintMethodComboChange(Sender);
    IVTCMethodComboChange(Sender);
    //IVTCFieldComboChange(Sender);
}

void __fastcall TFSKNewFiltersForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    // Save options
    switch (DeintMethodCombo->ItemIndex)
    {
    case 0:
        FSKNewForm->Deinterlace = false;
        break;

    case 1:
        FSKNewForm->Deinterlace     = true;
        FSKNewForm->FullDeinterlace = false;
        break;

    case 2:
        FSKNewForm->Deinterlace     = true;
        FSKNewForm->FullDeinterlace = true;
        break;
    }

    switch (IVTCMethodCombo->ItemIndex)
    {
    case 0:
        FSKNewForm->IVTC = false;
        break;

    case 1:
        FSKNewForm->IVTC        = true;
        FSKNewForm->ComplexIVTC = false;
        break;

    case 2:
        FSKNewForm->IVTC        = true;
        FSKNewForm->ComplexIVTC = true;
        break;
    }

    FSKNewForm->IsTFF = !IVTCFieldCombo->ItemIndex;
    FSKNewForm->S4_UpdateDecimate();

    // Enable parent form
    FSKNewForm->Enabled = true;
}

void __fastcall TFSKNewFiltersForm::IVTCMethodComboChange(TObject *Sender)
{
    if (!IsActive)
        return;

    if (IVTCMethodCombo->ItemIndex == 2)
    {
        IVTCFieldLabel->Enabled = true;
        IVTCFieldCombo->Enabled = true;
    }
    else
    {
        IVTCFieldLabel->Enabled = false;
        IVTCFieldCombo->Enabled = false;
    }

    if (IVTCMethodCombo->ItemIndex)
    {
        DeintMethodCombo->ItemIndex = 0;
        DeintMethodLabel->Enabled = false;
        DeintMethodCombo->Enabled = false;
    }
    else
    {
        DeintMethodLabel->Enabled = true;
        DeintMethodCombo->Enabled = true;
    }
}
