/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FSKNewWait.cpp

	Abstract:
			FilmShrink "New Job" wait form

    License:
            GNU General Public License (GPL)

	Revision History:
			* Sep 30, 2004:  Created by Attila Afra

------------------------------------------------------------------------------
	Copyright  2004-2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#include <vcl.h>
#pragma hdrstop

// Includes
#include "FSKNewWait.h"

// VCL stuff
#pragma package(smart_init)
#pragma resource "*.dfm"

/*=============================================================================
    TFSKNewWaitForm
=============================================================================*/

// Global form pointer
TFSKNewWaitForm *FSKNewWaitForm;

/*-----------------------------------------------------------------------------
    TFSKNewWaitForm >> Constructors
-----------------------------------------------------------------------------*/

// Main constructor
__fastcall TFSKNewWaitForm::TFSKNewWaitForm(TForm *ParentForm, TThread *Thread) : TForm(Parent)
{
    // Initialization
    _ParentForm = ParentForm;

    // Start thread
    Thread->Resume();
}

/*-----------------------------------------------------------------------------
    TFSKNewWaitForm >> Events
-----------------------------------------------------------------------------*/

void __fastcall TFSKNewWaitForm::FormShow(TObject *Sender)
{
    _ParentForm->Enabled = false;
    Screen->Cursor       = crHourGlass;
}

void __fastcall TFSKNewWaitForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    Screen->Cursor       = crDefault;
    _ParentForm->Enabled = true;
}


