/*=============================================================================
    Project Name:
            FilmShrink

	Module Name:
			FilmShrink.cpp

	Abstract:
			FilmShrink main code

    License:
            GNU General Public License (GPL)

	Revision History:
			* Aug  9, 2004:  Created by Attila Afra
            * Jan 12, 2004:  Single instance restriction

------------------------------------------------------------------------------
	Copyright  2004-2005 Attila T. Afra. All rights reserved.
=============================================================================*/

#include <vcl.h>
#pragma hdrstop

// Includes
#include "FSKGlobal.h"
#include "FSKTemplate.h"
#include <stdio.h>

// Form usage
USEFORM("FSKMain.cpp", FSKMainForm);
USEFORM("FSKMenu.cpp", FSKMenuForm);
USEFORM("FSKNew.cpp", FSKNewForm);
USEFORM("FSKNewWait.cpp", FSKNewWaitForm);
USEFORM("FSKSplash.cpp", FSKSplashForm);
USEFORM("FSKNewFilters.cpp", FSKNewFiltersForm);
USEFORM("FSKNewCodec.cpp", FSKNewCodecForm);
USEFORM("FSKNewCrop.cpp", FSKNewCropForm);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    // Startup code
    if (!FSKStartup())
    {
        Application->MessageBoxA("FilmShrink is already running!", "FilmShrink", MB_OK | MB_ICONINFORMATION);
        return 1;
    }

    try
    {
        Application->Initialize();
        Application->Title = "FilmShrink";

        Application->CreateForm(__classid(TFSKMainForm), &FSKMainForm);
         Application->Run();
    }
    catch (Exception &exception)
    {
        Application->ShowException(&exception);
    }
    catch (...)
    {
        try
        {
            throw Exception("");
        }
        catch (Exception &exception)
        {
            Application->ShowException(&exception);
        }
    }

    // Terminate FilmShrink
    FSKTerminate();

    return 0;
}
