/*=============================================================================
	Module Name:
			MainMacros.h

	Abstract:
			Main form macros

    License:
            GNU General Public License (GPL)

	Revision History:
			* Aug  9, 2004:  Created by Attila Afra
            * Sep 26, 2004:  Increased flexibility
            * Nov 29, 2004:  Initialization added

------------------------------------------------------------------------------
	Copyright  2004 Attila Afra. All rights reserved.
=============================================================================*/

#ifndef MainMacrosH
#define MainMacrosH

// Initialization
#define MAIN_SHOW_INIT(MAINCLASS)   \
    MAINCLASS->Top = Top;           \
    MAINCLASS->Left = Left;         \
    MAINCLASS->Width = Width;       \
    MAINCLASS->Height = Height;

// WndProc method (private)
#define MAIN_WNDPROC_PROTO  void __fastcall WndProc(TMessage& Message);

#define MAIN_WNDPROC(TCLASS, MAINCLASS)                                      \
void __fastcall TCLASS::WndProc(TMessage& Message)                           \
{                                                                            \
    /* Trap messages */                                                      \
    switch (Message.Msg)                                                     \
    {                                                                        \
    case WM_SYSCOMMAND:                                                      \
        if (Message.WParam == SC_MINIMIZE)                                   \
        {                                                                    \
            /* Minimize the entire application and don't send the message */ \
            Application->Minimize();                                         \
            return;                                                          \
        }                                                                    \
        else                                                                 \
            /* Send the message */                                           \
            break;                                                           \
                                                                             \
    case WM_MOVE:                                                            \
        /* Move the main form too and send the message */                    \
        MAINCLASS->Top = Top;                                                \
        MAINCLASS->Left = Left;                                              \
        break;                                                               \
                                                                             \
    case WM_SIZE:                                                            \
        /* Resize the main form too and send the message */                  \
        MAINCLASS->Width = Width;                                            \
        MAINCLASS->Height = Height;                                          \
        break;                                                               \
    }                                                                        \
                                                                             \
    /* Send the message */                                                   \
    TWinControl::WndProc(Message);                                           \
}

#endif // MainMacrosH
