/*=============================================================================
	Module Name:
			Shutdown.h

	Abstract:
			Windows Shutdown API

    License:
            GNU General Public License (GPL)

	Revision History:
			* Aug 22, 2004:  Created by Attila Afra

------------------------------------------------------------------------------
	Copyright  2004 Attila Afra. All rights reserved.
=============================================================================*/

#ifndef __SHUTDOWN_H_
#define __SHUTDOWN_H_

// Shutdown action enum
enum EShutdownAction
{
    SA_PowerOff,    // power off the system
    SA_Reboot,      // reboot the system
    SA_LogOff       // log off the current user
};

// Shutdown functions
bool Shutdown(EShutdownAction Action);
bool FastShutdown(EShutdownAction Action);

#endif // __SHUTDOWN_H_
